import{View}from"../base.mjs";import{ImageView}from"../image.mjs";import{ElementBuilder}from"../../base/builder.mjs";import{NumberInputView}from"../../forms/input.mjs";import{isEmpty,kebabCase,isEquivalent,getPointerEventCoordinates,bindPointerUntilRelease}from"../../base/helpers.mjs";const E=new ElementBuilder;class SampleChooserView extends View{static tagName="enfugue-sample-chooser";static loopIcon="fa-solid fa-rotate-left";static loopTooltip="Loop the video, restarting it after it has completed.";static playIcon="fa-solid fa-play";static playTooltip="Play the animation.";static playbackRate=8;static playbackRateTooltip="The playback rate of the animation in frames per second.";static noSamplesLabel="No samples yet. When you generate one or more images, their thumbnails will appear here.";constructor(t,e=[],i=!1){super(t),this.loopAnimationCallbacks=[],this.playAnimationCallbacks=[],this.setActiveCallbacks=[],this.setPlaybackRateCallbacks=[],this.imageViews=[],this.isAnimation=i,this.samples=e,this.activeIndex=0,this.playbackRate=this.constructor.playbackRate,this.playbackRateInput=new NumberInputView(t,"playbackRate",{min:1,max:60,value:this.constructor.playbackRate,tooltip:this.constructor.playbackRateTooltip,allowNull:!1}),this.playbackRateInput.onChange((()=>this.setPlaybackRate(this.playbackRateInput.getValue(),!1)))}onLoopAnimation(t){this.loopAnimationCallbacks.push(t)}onPlayAnimation(t){this.playAnimationCallbacks.push(t)}onSetActive(t){this.setActiveCallbacks.push(t)}onSetPlaybackRate(t){this.setPlaybackRateCallbacks.push(t)}setIsAnimation(t){this.isAnimation=t,isEmpty(this.node)||(t?this.node.addClass("animation"):this.node.removeClass("animation"))}setLoopAnimation(t,e=!0){for(let e of this.loopAnimationCallbacks)e(t);if(!isEmpty(this.node)&&e){let e=this.node.find(".loop");t?e.addClass("active"):e.removeClass("active")}}setPlayAnimation(t,e=!0){for(let e of this.playAnimationCallbacks)e(t);if(!isEmpty(this.node)&&e){let e=this.node.find(".play");t?e.addClass("active"):e.removeClass("active")}}setActiveIndex(t,e=!0){if(this.activeIndex=t,e)for(let e of this.setActiveCallbacks)e(t);if(!isEmpty(this.imageViews))for(let e in this.imageViews){let i=this.imageViews[e];e++==t?i.addClass("active"):i.removeClass("active")}}setPlaybackRate(t,e=!0){this.playbackRate=t;for(let e of this.setPlaybackRateCallbacks)e(t);e&&this.playbackRateInput.setValue(t,!1)}async setSamples(t){let e=!isEquivalent(this.samples,t);if(this.samples=t,!isEmpty(this.node)){let t=await this.node.find(".samples");if(isEmpty(this.samples))t.content(E.div().class("no-samples").content(this.constructor.noSamplesLabel)),this.imageViews=[];else if(e){let t=await this.node.find(".samples"),e=!1;isEmpty(this.imageViews)&&(t.empty(),e=!0);for(let i in this.samples){let s,a,o=this.samples[i];if(this.imageViews.length<=i?(s=new ImageView(this.config,o,!1),await s.waitForLoad(),a=await s.getNode(),a.on("click",(()=>{this.setActiveIndex(i)})),this.imageViews.push(s),t.append(a),e=!0):(s=this.imageViews[i],s.setImage(o),await s.waitForLoad(),a=await s.getNode()),null!==this.activeIndex&&this.activeIndex==i?s.addClass("active"):s.removeClass("active"),this.isAnimation){let t=100/this.samples.length;a.css("width",`${t}%`)}else a.css("width",null)}e&&t.render()}}}async build(){let t,e,i=await super.build(),s=E.i().addClass("loop").addClass(this.constructor.loopIcon).data("tooltip",this.constructor.loopTooltip).on("click",(()=>{s.toggleClass("active"),this.setLoopAnimation(s.hasClass("active"),!1)})),a=E.i().addClass("play").addClass(this.constructor.playIcon).data("tooltip",this.constructor.playTooltip).on("click",(()=>{a.toggleClass("active"),this.setPlayAnimation(a.hasClass("active"),!1)})),o=E.div().class("samples"),l=!1,n=t=>{let e=o.element.getBoundingClientRect(),[i,s]=getPointerEventCoordinates(t,o.element),a=i<0?0:i>e.width?1:i/e.width;return Math.min(Math.floor(a*this.samples.length),this.samples.length-1)};if(o.on("wheel",(t=>{t.preventDefault(),o.element.scrollLeft+=t.deltaY/10})).on("touchstart",(i=>{this.isAnimation?(i.preventDefault(),i.stopPropagation(),l=!0,this.setActiveIndex(n(i)),bindPointerUntilRelease((t=>{l&&this.setActiveIndex(n(t))}),(t=>{l=!1}))):(t={x:i.touches[0].clientX,y:i.touches[0].clientY},e=o.element.scrollLeft)})).on("touchmove",(i=>{if(this.isAnimation)return;let s={x:i.touches[0].clientX,y:i.touches[0].clientY};if(isEmpty(t))t=s,e=o.element.scrollLeft;else{let i={x:s.x-t.x,y:s.y-t.y};o.element.scrollLeft=e-i.x}})).on("mousedown",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),l=!0,this.setActiveIndex(n(t)),bindPointerUntilRelease((t=>{l&&this.setActiveIndex(n(t))}),(t=>{l=!1})))})).on("mousemove",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),l&&this.setActiveIndex(n(t)))})).on("mouseup",(t=>{this.isAnimation&&(t.preventDefault(),t.stopPropagation(),l=!1)})),isEmpty(this.samples))o.append(E.div().class("no-samples").content(this.constructor.noSamplesLabel));else for(let t in this.samples){let e,i,s=this.samples[t];this.imageViews.length<=t?(e=new ImageView(this.config,s,!1),i=await e.getNode(),i.on("click",(()=>{this.setActiveIndex(t)})),this.imageViews.push(e)):(e=this.imageViews[t],e.setImage(s),i=await e.getNode()),null!==this.activeIndex&&this.activeIndex===t?e.addClass("active"):e.removeClass("active"),o.append(i)}return i.content(o,E.div().class("playback-rate").content(await this.playbackRateInput.getNode(),E.span().content("fps")),s,a),this.isAnimation&&i.addClass("animation"),i}}export{SampleChooserView};
